//+------------------------------------------------------------------+
//|                                               Custom TRSI vM.mq4 |
//|                  Programmed by Jens Krotseng, adjusted by Martin |
//|                                  TRSI is a proprietary indicator |
//|                  copyright Neal Hughes http://www.fibmarkets.com |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window

#property indicator_minimum 0
#property indicator_maximum 100

#property  indicator_buffers 5
#property  indicator_color1  Green
#property  indicator_color2  Blue
#property  indicator_color3  Red
#property  indicator_color4  Gray
#property  indicator_color5  Yellow
#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_width3  1

//---- indicator parameters
extern int EmaPeriods=3;
extern int RSIPeriods=14;
extern int SmaPeriods=5;

//---- buffers
double     Rsi[];
double     EmaRsi[];
double     EmaEmaRsi[];
double     SI[];
double     TR[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
 {


//---- 2 additional buffers are used for calculating the indicators
  IndicatorBuffers(5);
  SetIndexBuffer(3,EmaRsi);
  SetIndexBuffer(4,EmaEmaRsi);


//---- indicator buffers mapping
  SetIndexBuffer(0,Rsi);
  SetIndexBuffer(1,SI);
  SetIndexBuffer(2,TR);


//---- name for DataWindow and indicator subwindow label
  IndicatorShortName("TRSI vM()");
  SetIndexLabel(0,"RSI(14)");  
  SetIndexLabel(1,"SI");
  SetIndexLabel(2,"TR");
  SetIndexLabel(3,"EmaRSI");
  SetIndexLabel(4,"EmaEmaRSI");

//---- drawing settings
  SetIndexStyle(0,DRAW_NONE);
  SetIndexStyle(1,DRAW_LINE);
  SetIndexStyle(2,DRAW_LINE);
  SetIndexStyle(3,DRAW_LINE);
  SetIndexStyle(4,DRAW_NONE);
  
  SetIndexDrawBegin(0,RSIPeriods);
  SetIndexDrawBegin(1,RSIPeriods);
  SetIndexDrawBegin(2,RSIPeriods);
  SetIndexDrawBegin(3,RSIPeriods);
  SetIndexDrawBegin(4,RSIPeriods);
  IndicatorDigits(Digits+2);



//---- initialization done
  return(0);
 }


//+------------------------------------------------------------------+
//| TRSI Calculations                                                |
//+------------------------------------------------------------------+
int start()
 {
  int limit;
  int counted_bars=IndicatorCounted();

//---- last counted bar will be recounted
  if(counted_bars>0) counted_bars--;
  limit=Bars-counted_bars;

//---- RSI (gray line)
  for(int i=0; i<limit; i++)
     Rsi[i]=iRSI(NULL,0,14,PRICE_CLOSE,i);

//---- EMA on RSI
  for(i=0; i<limit; i++)
     EmaRsi[i]=iMAOnArray(Rsi,Bars,EmaPeriods,0,MODE_EMA,i);

//---- Double EMA on RSI
  for(i=0; i<limit; i++)
     EmaEmaRsi[i]=iMAOnArray(EmaRsi,Bars,EmaPeriods,0,MODE_EMA,i);

//---- SI (blue line)
  for(i=0; i<limit; i++)
     SI[i]=iMAOnArray(EmaEmaRsi,Bars,EmaPeriods,0,MODE_EMA,i);

//---- TR (red line)
  for(i=0; i<limit; i++)
     TR[i]=iMAOnArray(SI,Bars,SmaPeriods,0,MODE_EMA,i+3);



//---- done
  return(0);
 }
//+------------------------------------------------------------------+


